program sol;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, sysutils;

var f1,f2:text;
var p1,p2,n,m,d,k,p:int64;
var i:integer;
var s:string;

function Parse(s:String):int64;
begin
  result:=StrToInt(Copy(s,1,pos('.',s)-1));
  Delete(s,1,pos('.',s));
  result:=result+StrToInt(Copy(s,1,pos('.',s)-1))*d;
  Delete(s,1,pos('.',s));
  result:=result+StrToInt(s)*d*m;
end;

function Convert(c:int64):int64;
var r:int64;
var rz:boolean;
begin
  if (p1 div p2)<1 then begin result:=0; exit; end;
  r:=(c mod p1)+1;
  result:=(r*p2 div p1);
  if (((r-1)*p2 div p1)<>result) then rz:=true else rz:=false;
  if ((r*p2 mod p1)>0) then inc(result);
  if (rz) and ((r*p2 mod p1)<>0) then result:=0;
end;

begin
  assignfile(f1,'input.txt');
  assignfile(f2,'output.txt');
  reset(f1);
  rewrite(f2);
  readln(f1,n,m,d,k,p);
  p1:=m*d*k; p2:=p;
  for i:=1 to n do begin
      readln(f1,s);
      write(f2,Convert(Parse(s)),' ');
  end;
  closefile(f2);
  closefile(f1);
end.

