program gen2;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, sysutils, math;

type TTest=record
  z,N,M,D,K,P:int64;
  Dates:array[1..1000] of string;
end;

function Chk(c:int64):int64;
begin
     result:=c;
     if c<=0 then result:=1;
     if c>1000 then result:=1000;
end;

function Chk2(c:int64):int64;
begin
     result:=c;
     if c<0 then result:=0;
     if c>999 then result:=999;
end;

function GenerateTest(DatesValue, MonthsValue, DaysValue, Rotation, SizeConst, Size:int64):TTest;
var s:string;
var i:integer;
begin
     result.z:=0;
     result.N:=chk((DatesValue div 2)-Random(DatesValue)+DatesValue+1);
     result.M:=chk(Random(MonthsValue)+1);
     result.D:=chk(Random(DaysValue)+1);
     result.K:=chk(Rotation);
     result.P:=chk(Random(Size)+1+SizeConst);
     for i:=1 to result.N do begin
         inc(result.z);
         s:=IntToStr(Chk2(Random(result.D)))+'.'+IntToStr(Chk2(Random(result.M)))+'.'+IntToStr(Random(1000));
         result.Dates[result.z]:=s;
     end;
end;

var f:text;
var p1,p2,n,m,d,k:int64;
var i:integer;
var t:TTest;

begin

  RandSeed:=StrToInt(ParamStr(1));
  n:=StrToInt(ParamStr(2));
  m:=StrToInt(ParamStr(3));
  d:=StrToInt(ParamStr(4));
  k:=StrToInt(ParamStr(5));
  p1:=StrToInt(ParamStr(6));
  p2:=StrToInt(ParamStr(7));

  //RandSeed:=888;  n:=1000; m:=50; d:=50; k:=1000; p1:=1000; p2:=1000;
  t:=GenerateTest(n,m,d,k,p1,p2);
  assignfile(f, 'input.txt');
  rewrite(f);
  writeln(f,t.n,' ', t.m,' ', t.d,' ', t.k,' ', t.p);
  for i:=1 to t.z do
      writeln(f,t.dates[i]);
  closefile(f);
end.


